﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using System.Drawing;
using Syncfusion.Pdf.Parsing;
using Syncfusion.HtmlConverter;
using System.IO;
using Syncfusion.Pdf.HtmlToPdf;
using System.Threading;

namespace WebSample
{
    public partial class _Default : System.Web.UI.Page
    {

      
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        MemoryStream ms = new MemoryStream();
        protected void generate_click(object sender, EventArgs e)
        {

           

            //Run as single thread 
            Thread t = new Thread(new ThreadStart(DrawHTML));

            t.SetApartmentState(ApartmentState.STA);

            t.Start();

            t.Join();

            t.Abort();
            //Load a PDF document
            PdfLoadedDocument ldoc = new PdfLoadedDocument(ms);

            
            //Create booklet with two sides               
            PdfDocument doc = PdfBookletCreator.CreateBooklet(ldoc, new SizeF(600f, 600f),false);
          
          
            if (InsideBrowser.Checked)
                doc.Save("Booklet.pdf", HttpContext.Current.ApplicationInstance.Response, HttpReadType.Open);
            else
                doc.Save("Booklet.pdf", HttpContext.Current.ApplicationInstance.Response, HttpReadType.Save);
            doc.Close(true);
        
        }

        private void DrawHTML( )
        {

            PdfDocument document = new PdfDocument();


            PdfPage page = document.Pages.Add();
            SizeF pageSize = SizeF.Empty;
            PdfUnitConvertor convertor = new PdfUnitConvertor();
            float width = -1;
            float height = -1;
            AspectRatio dimension = AspectRatio.None;

            // Layout format for Metafile.
            PdfMetafileLayoutFormat metafileFormat = new PdfMetafileLayoutFormat();
           /// metafileFormat.Break = PdfLayoutBreakType.FitPage;
            metafileFormat.Layout = PdfLayoutType.Paginate;

            width = convertor.ConvertToPixels(document.PageSettings.Width, PdfGraphicsUnit.Point);
            height = convertor.ConvertToPixels(document.PageSettings.Height, PdfGraphicsUnit.Point);




            // Create a new instance of HtmlConverter class.
            using (HtmlConverter html = new HtmlConverter())
            {
                // Turn on JavaScript execution.
                html.EnableJavaScript = true;

                // Enable auto detect page break.
                html.AutoDetectPageBreak = true;

                // Enable hyperlinks in the document.
                html.EnableHyperlinks = true;

                using (HtmlToPdfResult result = html.Convert(Server.MapPath(@"\Data\new  3.html"), ImageType.Metafile, (int)width, (int)height, AspectRatio.FitPageSize))
                {
                    if (result.RenderedImage == null)
                        return;

                    // Draw metafile in PdfPage.
                    result.Render(page, metafileFormat);
                }
            }
          

            // Save and close the document.
            document.Save(ms);
            document.Close(true);
        }
    }
}
